/* rygel-base-configuration.c generated by valac 0.20.1, the Vala compiler
 * generated from rygel-base-configuration.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define RYGEL_TYPE_CONFIGURATION (rygel_configuration_get_type ())
#define RYGEL_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CONFIGURATION, RygelConfiguration))
#define RYGEL_IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CONFIGURATION))
#define RYGEL_CONFIGURATION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_TYPE_CONFIGURATION, RygelConfigurationIface))

typedef struct _RygelConfiguration RygelConfiguration;
typedef struct _RygelConfigurationIface RygelConfigurationIface;

#define RYGEL_TYPE_BASE_CONFIGURATION (rygel_base_configuration_get_type ())
#define RYGEL_BASE_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_BASE_CONFIGURATION, RygelBaseConfiguration))
#define RYGEL_BASE_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_BASE_CONFIGURATION, RygelBaseConfigurationClass))
#define RYGEL_IS_BASE_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_BASE_CONFIGURATION))
#define RYGEL_IS_BASE_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_BASE_CONFIGURATION))
#define RYGEL_BASE_CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_BASE_CONFIGURATION, RygelBaseConfigurationClass))

typedef struct _RygelBaseConfiguration RygelBaseConfiguration;
typedef struct _RygelBaseConfigurationClass RygelBaseConfigurationClass;
typedef struct _RygelBaseConfigurationPrivate RygelBaseConfigurationPrivate;

struct _RygelConfigurationIface {
	GTypeInterface parent_iface;
	gboolean (*get_upnp_enabled) (RygelConfiguration* self, GError** error);
	gchar* (*get_interface) (RygelConfiguration* self, GError** error);
	gchar** (*get_interfaces) (RygelConfiguration* self, GError** error);
	gint (*get_port) (RygelConfiguration* self, GError** error);
	gboolean (*get_transcoding) (RygelConfiguration* self, GError** error);
	gboolean (*get_allow_upload) (RygelConfiguration* self, GError** error);
	gboolean (*get_allow_deletion) (RygelConfiguration* self, GError** error);
	gchar* (*get_log_levels) (RygelConfiguration* self, GError** error);
	gchar* (*get_plugin_path) (RygelConfiguration* self, GError** error);
	gchar* (*get_engine_path) (RygelConfiguration* self, GError** error);
	gchar* (*get_media_engine) (RygelConfiguration* self, GError** error);
	gchar* (*get_video_upload_folder) (RygelConfiguration* self, GError** error);
	gchar* (*get_music_upload_folder) (RygelConfiguration* self, GError** error);
	gchar* (*get_picture_upload_folder) (RygelConfiguration* self, GError** error);
	gboolean (*get_enabled) (RygelConfiguration* self, const gchar* section, GError** error);
	gchar* (*get_title) (RygelConfiguration* self, const gchar* section, GError** error);
	gchar* (*get_string) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
	GeeArrayList* (*get_string_list) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
	gint (*get_int) (RygelConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error);
	GeeArrayList* (*get_int_list) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
	gboolean (*get_bool) (RygelConfiguration* self, const gchar* section, const gchar* key, GError** error);
};

struct _RygelBaseConfiguration {
	GObject parent_instance;
	RygelBaseConfigurationPrivate * priv;
};

struct _RygelBaseConfigurationClass {
	GObjectClass parent_class;
	gboolean (*get_upnp_enabled) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_interface) (RygelBaseConfiguration* self, GError** error);
	gchar** (*get_interfaces) (RygelBaseConfiguration* self, GError** error);
	gint (*get_port) (RygelBaseConfiguration* self, GError** error);
	gboolean (*get_transcoding) (RygelBaseConfiguration* self, GError** error);
	gboolean (*get_allow_upload) (RygelBaseConfiguration* self, GError** error);
	gboolean (*get_allow_deletion) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_log_levels) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_plugin_path) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_engine_path) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_media_engine) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_video_upload_folder) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_music_upload_folder) (RygelBaseConfiguration* self, GError** error);
	gchar* (*get_picture_upload_folder) (RygelBaseConfiguration* self, GError** error);
	gboolean (*get_enabled) (RygelBaseConfiguration* self, const gchar* section, GError** error);
	gchar* (*get_title) (RygelBaseConfiguration* self, const gchar* section, GError** error);
	gchar* (*get_string) (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
	GeeArrayList* (*get_string_list) (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
	gint (*get_int) (RygelBaseConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error);
	GeeArrayList* (*get_int_list) (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
	gboolean (*get_bool) (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
};

typedef enum  {
	RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET,
	RYGEL_CONFIGURATION_ERROR_VALUE_OUT_OF_RANGE
} RygelConfigurationError;
#define RYGEL_CONFIGURATION_ERROR rygel_configuration_error_quark ()

static gpointer rygel_base_configuration_parent_class = NULL;
static RygelConfigurationIface* rygel_base_configuration_rygel_configuration_parent_iface = NULL;

GType rygel_configuration_get_type (void) G_GNUC_CONST;
GType rygel_base_configuration_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_BASE_CONFIGURATION_DUMMY_PROPERTY
};
gboolean rygel_base_configuration_get_upnp_enabled (RygelBaseConfiguration* self, GError** error);
static gboolean rygel_base_configuration_real_get_upnp_enabled (RygelBaseConfiguration* self, GError** error);
GQuark rygel_configuration_error_quark (void);
gchar* rygel_base_configuration_get_interface (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_interface (RygelBaseConfiguration* self, GError** error);
gchar** rygel_base_configuration_get_interfaces (RygelBaseConfiguration* self, GError** error);
static gchar** rygel_base_configuration_real_get_interfaces (RygelBaseConfiguration* self, GError** error);
gint rygel_base_configuration_get_port (RygelBaseConfiguration* self, GError** error);
static gint rygel_base_configuration_real_get_port (RygelBaseConfiguration* self, GError** error);
gboolean rygel_base_configuration_get_transcoding (RygelBaseConfiguration* self, GError** error);
static gboolean rygel_base_configuration_real_get_transcoding (RygelBaseConfiguration* self, GError** error);
gboolean rygel_base_configuration_get_allow_upload (RygelBaseConfiguration* self, GError** error);
static gboolean rygel_base_configuration_real_get_allow_upload (RygelBaseConfiguration* self, GError** error);
gboolean rygel_base_configuration_get_allow_deletion (RygelBaseConfiguration* self, GError** error);
static gboolean rygel_base_configuration_real_get_allow_deletion (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_log_levels (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_log_levels (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_plugin_path (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_plugin_path (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_engine_path (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_engine_path (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_media_engine (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_media_engine (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_video_upload_folder (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_video_upload_folder (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_music_upload_folder (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_music_upload_folder (RygelBaseConfiguration* self, GError** error);
gchar* rygel_base_configuration_get_picture_upload_folder (RygelBaseConfiguration* self, GError** error);
static gchar* rygel_base_configuration_real_get_picture_upload_folder (RygelBaseConfiguration* self, GError** error);
gboolean rygel_base_configuration_get_enabled (RygelBaseConfiguration* self, const gchar* section, GError** error);
static gboolean rygel_base_configuration_real_get_enabled (RygelBaseConfiguration* self, const gchar* section, GError** error);
gchar* rygel_base_configuration_get_title (RygelBaseConfiguration* self, const gchar* section, GError** error);
static gchar* rygel_base_configuration_real_get_title (RygelBaseConfiguration* self, const gchar* section, GError** error);
gchar* rygel_base_configuration_get_string (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
static gchar* rygel_base_configuration_real_get_string (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
GeeArrayList* rygel_base_configuration_get_string_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
static GeeArrayList* rygel_base_configuration_real_get_string_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
gint rygel_base_configuration_get_int (RygelBaseConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error);
static gint rygel_base_configuration_real_get_int (RygelBaseConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error);
GeeArrayList* rygel_base_configuration_get_int_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
static GeeArrayList* rygel_base_configuration_real_get_int_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
gboolean rygel_base_configuration_get_bool (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
static gboolean rygel_base_configuration_real_get_bool (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error);
RygelBaseConfiguration* rygel_base_configuration_new (void);
RygelBaseConfiguration* rygel_base_configuration_construct (GType object_type);


static gboolean rygel_base_configuration_real_get_upnp_enabled (RygelBaseConfiguration* self, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 30 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 30 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 30 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 30 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 30 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 29 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 187 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_upnp_enabled (RygelBaseConfiguration* self, GError** error) {
#line 29 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_upnp_enabled (self, error);
#line 196 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_interface (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 34 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 34 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 34 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 34 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 34 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 33 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 217 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_interface (RygelBaseConfiguration* self, GError** error) {
#line 33 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_interface (self, error);
#line 226 "rygel-base-configuration.c"
}


static gchar** rygel_base_configuration_real_get_interfaces (RygelBaseConfiguration* self, GError** error) {
	gchar** result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 38 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 247 "rygel-base-configuration.c"
}


gchar** rygel_base_configuration_get_interfaces (RygelBaseConfiguration* self, GError** error) {
#line 38 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_interfaces (self, error);
#line 256 "rygel-base-configuration.c"
}


static gint rygel_base_configuration_real_get_port (RygelBaseConfiguration* self, GError** error) {
	gint result = 0;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return 0;
#line 42 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 277 "rygel-base-configuration.c"
}


gint rygel_base_configuration_get_port (RygelBaseConfiguration* self, GError** error) {
#line 42 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_port (self, error);
#line 286 "rygel-base-configuration.c"
}


static gboolean rygel_base_configuration_real_get_transcoding (RygelBaseConfiguration* self, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 47 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 47 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 47 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 47 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 47 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 46 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 307 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_transcoding (RygelBaseConfiguration* self, GError** error) {
#line 46 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_transcoding (self, error);
#line 316 "rygel-base-configuration.c"
}


static gboolean rygel_base_configuration_real_get_allow_upload (RygelBaseConfiguration* self, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 51 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 51 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 51 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 51 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 51 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 337 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_allow_upload (RygelBaseConfiguration* self, GError** error) {
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_allow_upload (self, error);
#line 346 "rygel-base-configuration.c"
}


static gboolean rygel_base_configuration_real_get_allow_deletion (RygelBaseConfiguration* self, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 55 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 55 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 55 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 55 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 55 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 54 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 367 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_allow_deletion (RygelBaseConfiguration* self, GError** error) {
#line 54 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_allow_deletion (self, error);
#line 376 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_log_levels (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 58 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 397 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_log_levels (RygelBaseConfiguration* self, GError** error) {
#line 58 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_log_levels (self, error);
#line 406 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_plugin_path (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 62 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 427 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_plugin_path (RygelBaseConfiguration* self, GError** error) {
#line 62 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_plugin_path (self, error);
#line 436 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_engine_path (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 66 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 457 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_engine_path (RygelBaseConfiguration* self, GError** error) {
#line 66 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_engine_path (self, error);
#line 466 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_media_engine (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 70 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 487 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_media_engine (RygelBaseConfiguration* self, GError** error) {
#line 70 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_media_engine (self, error);
#line 496 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_video_upload_folder (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 74 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 517 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_video_upload_folder (RygelBaseConfiguration* self, GError** error) {
#line 74 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_video_upload_folder (self, error);
#line 526 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_music_upload_folder (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 79 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 79 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 79 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 79 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 79 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 547 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_music_upload_folder (RygelBaseConfiguration* self, GError** error) {
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_music_upload_folder (self, error);
#line 556 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_picture_upload_folder (RygelBaseConfiguration* self, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 83 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 83 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 83 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 83 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 83 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 82 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 577 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_picture_upload_folder (RygelBaseConfiguration* self, GError** error) {
#line 82 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_picture_upload_folder (self, error);
#line 586 "rygel-base-configuration.c"
}


static gboolean rygel_base_configuration_real_get_enabled (RygelBaseConfiguration* self, const gchar* section, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 86 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 87 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 87 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 87 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 87 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 87 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 86 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 609 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_enabled (RygelBaseConfiguration* self, const gchar* section, GError** error) {
#line 86 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_enabled (self, section, error);
#line 618 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_title (RygelBaseConfiguration* self, const gchar* section, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 90 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 91 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 91 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 91 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 91 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 91 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 90 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 641 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_title (RygelBaseConfiguration* self, const gchar* section, GError** error) {
#line 90 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_title (self, section, error);
#line 650 "rygel-base-configuration.c"
}


static gchar* rygel_base_configuration_real_get_string (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 675 "rygel-base-configuration.c"
}


gchar* rygel_base_configuration_get_string (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_string (self, section, key, error);
#line 684 "rygel-base-configuration.c"
}


static GeeArrayList* rygel_base_configuration_real_get_string_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
	GeeArrayList* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 709 "rygel-base-configuration.c"
}


GeeArrayList* rygel_base_configuration_get_string_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_string_list (self, section, key, error);
#line 718 "rygel-base-configuration.c"
}


static gint rygel_base_configuration_real_get_int (RygelBaseConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error) {
	gint result = 0;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, 0);
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (key != NULL, 0);
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return 0;
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 743 "rygel-base-configuration.c"
}


gint rygel_base_configuration_get_int (RygelBaseConfiguration* self, const gchar* section, const gchar* key, gint min, gint max, GError** error) {
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_int (self, section, key, min, max, error);
#line 752 "rygel-base-configuration.c"
}


static GeeArrayList* rygel_base_configuration_real_get_int_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
	GeeArrayList* result = NULL;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, NULL);
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 117 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 117 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 117 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 117 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 117 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return NULL;
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 777 "rygel-base-configuration.c"
}


GeeArrayList* rygel_base_configuration_get_int_list (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_int_list (self, section, key, error);
#line 786 "rygel-base-configuration.c"
}


static gboolean rygel_base_configuration_real_get_bool (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GError* _tmp1_;
	GError * _inner_error_ = NULL;
#line 120 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (section != NULL, FALSE);
#line 120 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp0_ = _ ("Not implemented");
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_tmp1_ = g_error_new_literal (RYGEL_CONFIGURATION_ERROR, RYGEL_CONFIGURATION_ERROR_NO_VALUE_SET, _tmp0_);
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	_inner_error_ = _tmp1_;
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_propagate_error (error, _inner_error_);
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return FALSE;
#line 120 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return result;
#line 811 "rygel-base-configuration.c"
}


gboolean rygel_base_configuration_get_bool (RygelBaseConfiguration* self, const gchar* section, const gchar* key, GError** error) {
#line 120 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return RYGEL_BASE_CONFIGURATION_GET_CLASS (self)->get_bool (self, section, key, error);
#line 820 "rygel-base-configuration.c"
}


RygelBaseConfiguration* rygel_base_configuration_construct (GType object_type) {
	RygelBaseConfiguration * self = NULL;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	self = (RygelBaseConfiguration*) g_object_new (object_type, NULL);
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return self;
#line 830 "rygel-base-configuration.c"
}


RygelBaseConfiguration* rygel_base_configuration_new (void) {
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	return rygel_base_configuration_construct (RYGEL_TYPE_BASE_CONFIGURATION);
#line 837 "rygel-base-configuration.c"
}


static void rygel_base_configuration_class_init (RygelBaseConfigurationClass * klass) {
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	rygel_base_configuration_parent_class = g_type_class_peek_parent (klass);
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_upnp_enabled = rygel_base_configuration_real_get_upnp_enabled;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_interface = rygel_base_configuration_real_get_interface;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_interfaces = rygel_base_configuration_real_get_interfaces;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_port = rygel_base_configuration_real_get_port;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_transcoding = rygel_base_configuration_real_get_transcoding;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_allow_upload = rygel_base_configuration_real_get_allow_upload;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_allow_deletion = rygel_base_configuration_real_get_allow_deletion;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_log_levels = rygel_base_configuration_real_get_log_levels;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_plugin_path = rygel_base_configuration_real_get_plugin_path;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_engine_path = rygel_base_configuration_real_get_engine_path;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_media_engine = rygel_base_configuration_real_get_media_engine;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_video_upload_folder = rygel_base_configuration_real_get_video_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_music_upload_folder = rygel_base_configuration_real_get_music_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_picture_upload_folder = rygel_base_configuration_real_get_picture_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_enabled = rygel_base_configuration_real_get_enabled;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_title = rygel_base_configuration_real_get_title;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_string = rygel_base_configuration_real_get_string;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_string_list = rygel_base_configuration_real_get_string_list;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_int = rygel_base_configuration_real_get_int;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_int_list = rygel_base_configuration_real_get_int_list;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	RYGEL_BASE_CONFIGURATION_CLASS (klass)->get_bool = rygel_base_configuration_real_get_bool;
#line 886 "rygel-base-configuration.c"
}


static void rygel_base_configuration_rygel_configuration_interface_init (RygelConfigurationIface * iface) {
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	rygel_base_configuration_rygel_configuration_parent_iface = g_type_interface_peek_parent (iface);
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_upnp_enabled = (gboolean (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_upnp_enabled;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_interface = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_interface;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_interfaces = (gchar** (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_interfaces;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_port = (gint (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_port;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_transcoding = (gboolean (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_transcoding;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_allow_upload = (gboolean (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_allow_upload;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_allow_deletion = (gboolean (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_allow_deletion;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_log_levels = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_log_levels;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_plugin_path = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_plugin_path;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_engine_path = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_engine_path;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_media_engine = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_media_engine;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_video_upload_folder = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_video_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_music_upload_folder = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_music_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_picture_upload_folder = (gchar* (*)(RygelConfiguration*, GError**)) rygel_base_configuration_get_picture_upload_folder;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_enabled = (gboolean (*)(RygelConfiguration*, const gchar*, GError**)) rygel_base_configuration_get_enabled;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_title = (gchar* (*)(RygelConfiguration*, const gchar*, GError**)) rygel_base_configuration_get_title;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_string = (gchar* (*)(RygelConfiguration*, const gchar*, const gchar*, GError**)) rygel_base_configuration_get_string;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_string_list = (GeeArrayList* (*)(RygelConfiguration*, const gchar*, const gchar*, GError**)) rygel_base_configuration_get_string_list;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_int = (gint (*)(RygelConfiguration*, const gchar*, const gchar*, gint, gint, GError**)) rygel_base_configuration_get_int;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_int_list = (GeeArrayList* (*)(RygelConfiguration*, const gchar*, const gchar*, GError**)) rygel_base_configuration_get_int_list;
#line 28 "/home/jens/Source/rygel/src/librygel-core/rygel-base-configuration.vala"
	iface->get_bool = (gboolean (*)(RygelConfiguration*, const gchar*, const gchar*, GError**)) rygel_base_configuration_get_bool;
#line 935 "rygel-base-configuration.c"
}


static void rygel_base_configuration_instance_init (RygelBaseConfiguration * self) {
}


/**
 * Base class that can be used for configuration implementations.
 *
 * Mainly useful to only implement a small subset of the configuration.
 */
GType rygel_base_configuration_get_type (void) {
	static volatile gsize rygel_base_configuration_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_base_configuration_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelBaseConfigurationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_base_configuration_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelBaseConfiguration), 0, (GInstanceInitFunc) rygel_base_configuration_instance_init, NULL };
		static const GInterfaceInfo rygel_configuration_info = { (GInterfaceInitFunc) rygel_base_configuration_rygel_configuration_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType rygel_base_configuration_type_id;
		rygel_base_configuration_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelBaseConfiguration", &g_define_type_info, 0);
		g_type_add_interface_static (rygel_base_configuration_type_id, RYGEL_TYPE_CONFIGURATION, &rygel_configuration_info);
		g_once_init_leave (&rygel_base_configuration_type_id__volatile, rygel_base_configuration_type_id);
	}
	return rygel_base_configuration_type_id__volatile;
}



