/* rygel-engine-loader.c generated by valac 0.22.0, the Vala compiler
 * generated from rygel-engine-loader.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <rygel-core.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gmodule.h>
#include <config.h>


#define RYGEL_TYPE_ENGINE_LOADER (rygel_engine_loader_get_type ())
#define RYGEL_ENGINE_LOADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_ENGINE_LOADER, RygelEngineLoader))
#define RYGEL_ENGINE_LOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_ENGINE_LOADER, RygelEngineLoaderClass))
#define RYGEL_IS_ENGINE_LOADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_ENGINE_LOADER))
#define RYGEL_IS_ENGINE_LOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_ENGINE_LOADER))
#define RYGEL_ENGINE_LOADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_ENGINE_LOADER, RygelEngineLoaderClass))

typedef struct _RygelEngineLoader RygelEngineLoader;
typedef struct _RygelEngineLoaderClass RygelEngineLoaderClass;
typedef struct _RygelEngineLoaderPrivate RygelEngineLoaderPrivate;

#define RYGEL_TYPE_MEDIA_ENGINE (rygel_media_engine_get_type ())
#define RYGEL_MEDIA_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_ENGINE, RygelMediaEngine))
#define RYGEL_MEDIA_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_MEDIA_ENGINE, RygelMediaEngineClass))
#define RYGEL_IS_MEDIA_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_ENGINE))
#define RYGEL_IS_MEDIA_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_MEDIA_ENGINE))
#define RYGEL_MEDIA_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_MEDIA_ENGINE, RygelMediaEngineClass))

typedef struct _RygelMediaEngine RygelMediaEngine;
typedef struct _RygelMediaEngineClass RygelMediaEngineClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))

struct _RygelEngineLoader {
	RygelRecursiveModuleLoader parent_instance;
	RygelEngineLoaderPrivate * priv;
};

struct _RygelEngineLoaderClass {
	RygelRecursiveModuleLoaderClass parent_class;
};

struct _RygelEngineLoaderPrivate {
	RygelMediaEngine* instance;
	gchar* engine_name;
};

typedef RygelMediaEngine* (*RygelEngineLoaderModuleInstanceFunc) (void* user_data);

static gpointer rygel_engine_loader_parent_class = NULL;

GType rygel_engine_loader_get_type (void) G_GNUC_CONST;
GType rygel_media_engine_get_type (void) G_GNUC_CONST;
#define RYGEL_ENGINE_LOADER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_TYPE_ENGINE_LOADER, RygelEngineLoaderPrivate))
enum  {
	RYGEL_ENGINE_LOADER_DUMMY_PROPERTY
};
RygelEngineLoader* rygel_engine_loader_new (void);
RygelEngineLoader* rygel_engine_loader_construct (GType object_type);
static gchar* rygel_engine_loader_get_config (void);
static void rygel_engine_loader_real_constructed (GObject* base);
RygelMediaEngine* rygel_engine_loader_load_engine (RygelEngineLoader* self);
static gboolean rygel_engine_loader_real_load_module_from_file (RygelRecursiveModuleLoader* base, GFile* file);
static gboolean rygel_engine_loader_real_load_module_from_info (RygelRecursiveModuleLoader* base, RygelPluginInformation* info);
static void rygel_engine_loader_finalize (GObject* obj);


RygelEngineLoader* rygel_engine_loader_construct (GType object_type) {
	RygelEngineLoader * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 32 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = rygel_engine_loader_get_config ();
#line 32 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp1_ = _tmp0_;
#line 32 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self = (RygelEngineLoader*) g_object_new (object_type, "base-path", _tmp1_, NULL);
#line 32 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_free0 (_tmp1_);
#line 31 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return self;
#line 110 "rygel-engine-loader.c"
}


RygelEngineLoader* rygel_engine_loader_new (void) {
#line 31 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return rygel_engine_loader_construct (RYGEL_TYPE_ENGINE_LOADER);
#line 117 "rygel-engine-loader.c"
}


static void rygel_engine_loader_real_constructed (GObject* base) {
	RygelEngineLoader * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 35 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self = (RygelEngineLoader*) base;
#line 36 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	G_OBJECT_CLASS (rygel_engine_loader_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_RECURSIVE_MODULE_LOADER, RygelRecursiveModuleLoader));
#line 38 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = rygel_recursive_module_loader_get_base_path ((RygelRecursiveModuleLoader*) self);
#line 38 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp1_ = _tmp0_;
#line 38 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (_tmp1_ == NULL) {
#line 136 "rygel-engine-loader.c"
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 39 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp2_ = rygel_engine_loader_get_config ();
#line 39 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp3_ = _tmp2_;
#line 39 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		rygel_recursive_module_loader_set_base_path ((RygelRecursiveModuleLoader*) self, _tmp3_);
#line 39 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (_tmp3_);
#line 147 "rygel-engine-loader.c"
	}
	{
		RygelMetaConfig* config = NULL;
		RygelMetaConfig* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 43 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp4_ = rygel_meta_config_get_default ();
#line 43 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		config = _tmp4_;
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp6_ = rygel_configuration_get_media_engine ((RygelConfiguration*) config, &_inner_error_);
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp5_ = _tmp6_;
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		if (_inner_error_ != NULL) {
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			_g_object_unref0 (config);
#line 167 "rygel-engine-loader.c"
			goto __catch26_g_error;
		}
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (self->priv->engine_name);
#line 44 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		self->priv->engine_name = _tmp5_;
#line 45 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp7_ = self->priv->engine_name;
#line 45 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_debug ("rygel-engine-loader.vala:45: Looking for specific engine named '%s", _tmp7_);
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_object_unref0 (config);
#line 180 "rygel-engine-loader.c"
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* _error_ = NULL;
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_error_ = _inner_error_;
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_inner_error_ = NULL;
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_error_free0 (_error_);
#line 192 "rygel-engine-loader.c"
	}
	__finally26:
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (_inner_error_ != NULL) {
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_clear_error (&_inner_error_);
#line 42 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		return;
#line 203 "rygel-engine-loader.c"
	}
}


/**
     * Load a media engine.
     */
static gpointer _g_object_ref0 (gpointer self) {
#line 56 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return self ? g_object_ref (self) : NULL;
#line 214 "rygel-engine-loader.c"
}


RygelMediaEngine* rygel_engine_loader_load_engine (RygelEngineLoader* self) {
	RygelMediaEngine* result = NULL;
	RygelMediaEngine* _tmp0_ = NULL;
	RygelMediaEngine* _tmp1_ = NULL;
#line 53 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	rygel_recursive_module_loader_load_modules_sync ((RygelRecursiveModuleLoader*) self, NULL);
#line 56 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = self->priv->instance;
#line 56 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 56 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	result = _tmp1_;
#line 56 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return result;
#line 234 "rygel-engine-loader.c"
}


static gboolean rygel_engine_loader_real_load_module_from_file (RygelRecursiveModuleLoader* base, GFile* file) {
	RygelEngineLoader * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	GModule* module = NULL;
	GFile* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	GModule* _tmp9_ = NULL;
	GModule* _tmp10_ = NULL;
	GModule* _tmp11_ = NULL;
	void* function = NULL;
	GModule* _tmp17_ = NULL;
	void* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	RygelEngineLoaderModuleInstanceFunc get_instance = NULL;
	void* _tmp21_ = NULL;
	void* get_instance_target = NULL;
	GModule* _tmp22_ = NULL;
	RygelEngineLoaderModuleInstanceFunc _tmp23_ = NULL;
	void* _tmp23__target = NULL;
	RygelMediaEngine* _tmp24_ = NULL;
#line 59 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self = (RygelEngineLoader*) base;
#line 59 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 60 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = self->priv->engine_name;
#line 60 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (_tmp0_ != NULL) {
#line 268 "rygel-engine-loader.c"
		GFile* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp1_ = file;
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp2_ = g_file_get_basename (_tmp1_);
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp3_ = _tmp2_;
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp4_ = self->priv->engine_name;
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp5_ = g_strcmp0 (_tmp3_, _tmp4_) != 0;
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (_tmp3_);
#line 61 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		if (_tmp5_) {
#line 62 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			result = TRUE;
#line 62 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			return result;
#line 292 "rygel-engine-loader.c"
		}
	}
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp6_ = file;
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp7_ = g_file_get_path (_tmp6_);
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp8_ = _tmp7_;
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp9_ = g_module_open (_tmp8_, G_MODULE_BIND_LOCAL);
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp10_ = _tmp9_;
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_free0 (_tmp8_);
#line 66 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	module = _tmp10_;
#line 67 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp11_ = module;
#line 67 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (_tmp11_ == NULL) {
#line 313 "rygel-engine-loader.c"
		GFile* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp12_ = file;
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp14_ = _tmp13_;
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp15_ = g_module_error ();
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_debug ("rygel-engine-loader.vala:68: Failed to load engine %s: %s", _tmp14_, _tmp15_);
#line 68 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (_tmp14_);
#line 71 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp16_ = self->priv->engine_name;
#line 71 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		if (_tmp16_ != NULL) {
#line 75 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			result = FALSE;
#line 75 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			_g_module_close0 (module);
#line 75 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			return result;
#line 341 "rygel-engine-loader.c"
		}
#line 78 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		result = TRUE;
#line 78 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_module_close0 (module);
#line 78 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		return result;
#line 349 "rygel-engine-loader.c"
	}
#line 82 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp17_ = module;
#line 82 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp19_ = g_module_symbol (_tmp17_, "module_get_instance", &_tmp18_);
#line 82 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	function = _tmp18_;
#line 82 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (!_tmp19_) {
#line 359 "rygel-engine-loader.c"
		const gchar* _tmp20_ = NULL;
#line 83 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp20_ = self->priv->engine_name;
#line 83 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		if (_tmp20_ != NULL) {
#line 87 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			result = FALSE;
#line 87 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			_g_module_close0 (module);
#line 87 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
			return result;
#line 371 "rygel-engine-loader.c"
		}
#line 90 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		result = TRUE;
#line 90 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_module_close0 (module);
#line 90 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		return result;
#line 379 "rygel-engine-loader.c"
	}
#line 93 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp21_ = function;
#line 93 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	get_instance = (RygelEngineLoaderModuleInstanceFunc) _tmp21_;
#line 93 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	get_instance_target = NULL;
#line 95 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp22_ = module;
#line 95 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	g_module_make_resident (_tmp22_);
#line 96 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp23_ = get_instance;
#line 96 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp23__target = get_instance_target;
#line 96 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp24_ = _tmp23_ (_tmp23__target);
#line 96 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_object_unref0 (self->priv->instance);
#line 96 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self->priv->instance = _tmp24_;
#line 98 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	result = FALSE;
#line 98 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_module_close0 (module);
#line 98 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return result;
#line 407 "rygel-engine-loader.c"
}


static gboolean rygel_engine_loader_real_load_module_from_info (RygelRecursiveModuleLoader* base, RygelPluginInformation* info) {
	RygelEngineLoader * self;
	gboolean result = FALSE;
	RygelPluginInformation* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 101 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self = (RygelEngineLoader*) base;
#line 101 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = info;
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp1_ = rygel_plugin_information_get_module_path (_tmp0_);
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp2_ = _tmp1_;
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp4_ = _tmp3_;
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp5_ = rygel_recursive_module_loader_load_module_from_file ((RygelRecursiveModuleLoader*) self, _tmp4_);
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp6_ = _tmp5_;
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_object_unref0 (_tmp4_);
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	result = _tmp6_;
#line 102 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return result;
#line 445 "rygel-engine-loader.c"
}


static gchar* rygel_engine_loader_get_config (void) {
	gchar* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_ = NULL;
	RygelMetaConfig* config = NULL;
	RygelMetaConfig* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 106 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp0_ = g_strdup (ENGINE_DIR);
#line 106 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	path = _tmp0_;
#line 107 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_tmp1_ = rygel_meta_config_get_default ();
#line 107 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	config = _tmp1_;
#line 464 "rygel-engine-loader.c"
	{
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 109 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp3_ = rygel_configuration_get_engine_path ((RygelConfiguration*) config, &_inner_error_);
#line 109 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_tmp2_ = _tmp3_;
#line 109 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		if (_inner_error_ != NULL) {
#line 474 "rygel-engine-loader.c"
			goto __catch27_g_error;
		}
#line 109 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (path);
#line 109 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		path = _tmp2_;
#line 481 "rygel-engine-loader.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* _error_ = NULL;
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_error_ = _inner_error_;
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_inner_error_ = NULL;
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_error_free0 (_error_);
#line 493 "rygel-engine-loader.c"
	}
	__finally27:
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	if (_inner_error_ != NULL) {
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_object_unref0 (config);
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		_g_free0 (path);
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		g_clear_error (&_inner_error_);
#line 108 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
		return NULL;
#line 508 "rygel-engine-loader.c"
	}
#line 112 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	result = path;
#line 112 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_object_unref0 (config);
#line 112 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	return result;
#line 516 "rygel-engine-loader.c"
}


static void rygel_engine_loader_class_init (RygelEngineLoaderClass * klass) {
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	rygel_engine_loader_parent_class = g_type_class_peek_parent (klass);
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	g_type_class_add_private (klass, sizeof (RygelEngineLoaderPrivate));
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	G_OBJECT_CLASS (klass)->constructed = rygel_engine_loader_real_constructed;
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	RYGEL_RECURSIVE_MODULE_LOADER_CLASS (klass)->load_module_from_file = rygel_engine_loader_real_load_module_from_file;
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	RYGEL_RECURSIVE_MODULE_LOADER_CLASS (klass)->load_module_from_info = rygel_engine_loader_real_load_module_from_info;
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_engine_loader_finalize;
#line 533 "rygel-engine-loader.c"
}


static void rygel_engine_loader_instance_init (RygelEngineLoader * self) {
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self->priv = RYGEL_ENGINE_LOADER_GET_PRIVATE (self);
#line 540 "rygel-engine-loader.c"
}


static void rygel_engine_loader_finalize (GObject* obj) {
	RygelEngineLoader * self;
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_ENGINE_LOADER, RygelEngineLoader);
#line 28 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_object_unref0 (self->priv->instance);
#line 29 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	_g_free0 (self->priv->engine_name);
#line 26 "/home/jens/Source/rygel/src/librygel-server/rygel-engine-loader.vala"
	G_OBJECT_CLASS (rygel_engine_loader_parent_class)->finalize (obj);
#line 554 "rygel-engine-loader.c"
}


/**
 * Load a media engine.
 */
GType rygel_engine_loader_get_type (void) {
	static volatile gsize rygel_engine_loader_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_engine_loader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelEngineLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_engine_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelEngineLoader), 0, (GInstanceInitFunc) rygel_engine_loader_instance_init, NULL };
		GType rygel_engine_loader_type_id;
		rygel_engine_loader_type_id = g_type_register_static (RYGEL_TYPE_RECURSIVE_MODULE_LOADER, "RygelEngineLoader", &g_define_type_info, 0);
		g_once_init_leave (&rygel_engine_loader_type_id__volatile, rygel_engine_loader_type_id);
	}
	return rygel_engine_loader_type_id__volatile;
}



