/* rygel-audio-transcoder.c generated by valac 0.22.0, the Vala compiler
 * generated from rygel-audio-transcoder.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <rygel-server.h>
#include <gst/pbutils/codec-utils.h>
#include <gst/pbutils/descriptions.h>
#include <gst/pbutils/encoding-profile.h>
#include <gst/pbutils/encoding-target.h>
#include <gst/pbutils/gstdiscoverer.h>
#include <gst/pbutils/gstpluginsbaseversion.h>
#include <gst/pbutils/install-plugins.h>
#include <gst/pbutils/missing-plugins.h>
#include <gst/pbutils/pbutils-enumtypes.h>
#include <gst/pbutils/pbutils.h>
#include <gst/gst.h>
#include <stdlib.h>
#include <string.h>
#include <libgupnp-av/gupnp-av.h>


#define RYGEL_TYPE_GST_TRANSCODER (rygel_gst_transcoder_get_type ())
#define RYGEL_GST_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoder))
#define RYGEL_GST_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoderClass))
#define RYGEL_IS_GST_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_TRANSCODER))
#define RYGEL_IS_GST_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_TRANSCODER))
#define RYGEL_GST_TRANSCODER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoderClass))

typedef struct _RygelGstTranscoder RygelGstTranscoder;
typedef struct _RygelGstTranscoderClass RygelGstTranscoderClass;
typedef struct _RygelGstTranscoderPrivate RygelGstTranscoderPrivate;

#define RYGEL_TYPE_AUDIO_TRANSCODER (rygel_audio_transcoder_get_type ())
#define RYGEL_AUDIO_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoder))
#define RYGEL_AUDIO_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoderClass))
#define RYGEL_IS_AUDIO_TRANSCODER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_AUDIO_TRANSCODER))
#define RYGEL_IS_AUDIO_TRANSCODER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_AUDIO_TRANSCODER))
#define RYGEL_AUDIO_TRANSCODER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoderClass))

typedef struct _RygelAudioTranscoder RygelAudioTranscoder;
typedef struct _RygelAudioTranscoderClass RygelAudioTranscoderClass;
typedef struct _RygelAudioTranscoderPrivate RygelAudioTranscoderPrivate;
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _RygelGstTranscoder {
	RygelTranscoder parent_instance;
	RygelGstTranscoderPrivate * priv;
};

struct _RygelGstTranscoderClass {
	RygelTranscoderClass parent_class;
	GstEncodingProfile* (*get_encoding_profile) (RygelGstTranscoder* self);
};

struct _RygelAudioTranscoder {
	RygelGstTranscoder parent_instance;
	RygelAudioTranscoderPrivate * priv;
	gint audio_bitrate;
	GstCaps* container_format;
	GstCaps* audio_codec_format;
};

struct _RygelAudioTranscoderClass {
	RygelGstTranscoderClass parent_class;
};


static gpointer rygel_audio_transcoder_parent_class = NULL;

GType rygel_gst_transcoder_get_type (void) G_GNUC_CONST;
GType rygel_audio_transcoder_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_AUDIO_TRANSCODER_DUMMY_PROPERTY
};
#define RYGEL_AUDIO_TRANSCODER_NO_CONTAINER NULL
RygelAudioTranscoder* rygel_audio_transcoder_new (const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension);
RygelAudioTranscoder* rygel_audio_transcoder_construct (GType object_type, const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension);
RygelGstTranscoder* rygel_gst_transcoder_construct (GType object_type, const gchar* mime_type, const gchar* dlna_profile, const gchar* extension);
RygelAudioTranscoder* rygel_audio_transcoder_new_with_class (const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension);
RygelAudioTranscoder* rygel_audio_transcoder_construct_with_class (GType object_type, const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension);
static GUPnPDIDLLiteResource* rygel_audio_transcoder_real_add_resource (RygelTranscoder* base, GUPnPDIDLLiteItem* didl_item, RygelMediaItem* item, RygelTranscodeManager* manager, GError** error);
static guint rygel_audio_transcoder_real_get_distance (RygelTranscoder* base, RygelMediaItem* item);
static GstEncodingProfile* rygel_audio_transcoder_real_get_encoding_profile (RygelGstTranscoder* base);
const gchar* rygel_gst_transcoder_get_preset (RygelGstTranscoder* self);
static void rygel_audio_transcoder_finalize (GObject* obj);


RygelAudioTranscoder* rygel_audio_transcoder_construct (GType object_type, const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension) {
	RygelAudioTranscoder * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp7_ = NULL;
	GstCaps* _tmp8_ = NULL;
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (content_type != NULL, NULL);
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (dlna_profile != NULL, NULL);
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (audio_codec_caps != NULL, NULL);
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = content_type;
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = dlna_profile;
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = extension;
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) rygel_gst_transcoder_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
#line 45 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = audio_bitrate;
#line 45 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_bitrate = _tmp3_;
#line 46 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = container_caps;
#line 46 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp4_ != NULL) {
#line 147 "rygel-audio-transcoder.c"
		const gchar* _tmp5_ = NULL;
		GstCaps* _tmp6_ = NULL;
#line 47 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp5_ = container_caps;
#line 47 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp6_ = gst_caps_from_string (_tmp5_);
#line 47 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_gst_caps_unref0 (self->container_format);
#line 47 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		self->container_format = _tmp6_;
#line 158 "rygel-audio-transcoder.c"
	}
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp7_ = audio_codec_caps;
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp8_ = gst_caps_from_string (_tmp7_);
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = _tmp8_;
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self;
#line 170 "rygel-audio-transcoder.c"
}


RygelAudioTranscoder* rygel_audio_transcoder_new (const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension) {
#line 37 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return rygel_audio_transcoder_construct (RYGEL_TYPE_AUDIO_TRANSCODER, content_type, dlna_profile, audio_bitrate, container_caps, audio_codec_caps, extension);
#line 177 "rygel-audio-transcoder.c"
}


RygelAudioTranscoder* rygel_audio_transcoder_construct_with_class (GType object_type, const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension) {
	RygelAudioTranscoder * self = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp7_ = NULL;
	GstCaps* _tmp8_ = NULL;
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (content_type != NULL, NULL);
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (dlna_profile != NULL, NULL);
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (audio_codec_caps != NULL, NULL);
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = content_type;
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = dlna_profile;
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = extension;
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) rygel_gst_transcoder_construct (object_type, _tmp0_, _tmp1_, _tmp2_);
#line 61 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = audio_bitrate;
#line 61 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_bitrate = _tmp3_;
#line 62 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = container_caps;
#line 62 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp4_ != NULL) {
#line 214 "rygel-audio-transcoder.c"
		const gchar* _tmp5_ = NULL;
		GstCaps* _tmp6_ = NULL;
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp5_ = container_caps;
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp6_ = gst_caps_from_string (_tmp5_);
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_gst_caps_unref0 (self->container_format);
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		self->container_format = _tmp6_;
#line 225 "rygel-audio-transcoder.c"
	}
#line 66 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp7_ = audio_codec_caps;
#line 66 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp8_ = gst_caps_from_string (_tmp7_);
#line 66 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 66 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = _tmp8_;
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self;
#line 237 "rygel-audio-transcoder.c"
}


RygelAudioTranscoder* rygel_audio_transcoder_new_with_class (const gchar* content_type, const gchar* dlna_profile, gint audio_bitrate, const gchar* container_caps, const gchar* audio_codec_caps, const gchar* extension) {
#line 53 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return rygel_audio_transcoder_construct_with_class (RYGEL_TYPE_AUDIO_TRANSCODER, content_type, dlna_profile, audio_bitrate, container_caps, audio_codec_caps, extension);
#line 244 "rygel-audio-transcoder.c"
}


static GUPnPDIDLLiteResource* rygel_audio_transcoder_real_add_resource (RygelTranscoder* base, GUPnPDIDLLiteItem* didl_item, RygelMediaItem* item, RygelTranscodeManager* manager, GError** error) {
	RygelAudioTranscoder * self;
	GUPnPDIDLLiteResource* result = NULL;
	GUPnPDIDLLiteResource* resource = NULL;
	GUPnPDIDLLiteItem* _tmp0_ = NULL;
	RygelMediaItem* _tmp1_ = NULL;
	RygelTranscodeManager* _tmp2_ = NULL;
	GUPnPDIDLLiteResource* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	GError * _inner_error_ = NULL;
#line 70 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 70 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (didl_item != NULL, NULL);
#line 70 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 70 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = didl_item;
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = item;
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = manager;
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = RYGEL_TRANSCODER_CLASS (rygel_audio_transcoder_parent_class)->add_resource ((RygelTranscoder*) G_TYPE_CHECK_INSTANCE_CAST (self, RYGEL_TYPE_GST_TRANSCODER, RygelGstTranscoder), _tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	resource = _tmp3_;
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_inner_error_ != NULL) {
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		g_propagate_error (error, _inner_error_);
#line 74 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return NULL;
#line 282 "rygel-audio-transcoder.c"
	}
#line 75 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (resource == NULL) {
#line 76 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = NULL;
#line 76 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_g_object_unref0 (resource);
#line 76 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 292 "rygel-audio-transcoder.c"
	}
#line 79 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = self->audio_bitrate;
#line 79 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	gupnp_didl_lite_resource_set_bitrate (resource, (_tmp4_ * 1000) / 8);
#line 81 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = resource;
#line 81 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 302 "rygel-audio-transcoder.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 89 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return self ? g_object_ref (self) : NULL;
#line 309 "rygel-audio-transcoder.c"
}


static guint rygel_audio_transcoder_real_get_distance (RygelTranscoder* base, RygelMediaItem* item) {
	RygelAudioTranscoder * self;
	guint result = 0U;
	gboolean _tmp0_ = FALSE;
	RygelMediaItem* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	RygelAudioItem* audio_item = NULL;
	RygelMediaItem* _tmp5_ = NULL;
	RygelAudioItem* _tmp6_ = NULL;
	guint distance = 0U;
	guint _tmp7_ = 0U;
	RygelAudioItem* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
#line 84 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 84 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	g_return_val_if_fail (item != NULL, 0U);
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = item;
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, RYGEL_TYPE_AUDIO_ITEM)) {
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = TRUE;
#line 337 "rygel-audio-transcoder.c"
	} else {
		RygelMediaItem* _tmp2_ = NULL;
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp2_ = item;
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, RYGEL_TYPE_VIDEO_ITEM);
#line 344 "rygel-audio-transcoder.c"
	}
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = _tmp0_;
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp3_) {
#line 350 "rygel-audio-transcoder.c"
		guint _tmp4_ = 0U;
#line 86 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp4_ = G_MAXUINT;
#line 86 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = _tmp4_;
#line 86 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 358 "rygel-audio-transcoder.c"
	}
#line 89 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp5_ = item;
#line 89 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, RYGEL_TYPE_AUDIO_ITEM) ? ((RygelAudioItem*) _tmp5_) : NULL);
#line 89 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	audio_item = _tmp6_;
#line 90 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp7_ = 0;
#line 90 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	distance = _tmp7_;
#line 92 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp8_ = audio_item;
#line 92 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp9_ = rygel_audio_item_get_bitrate (_tmp8_);
#line 92 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp10_ = _tmp9_;
#line 92 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp10_ > 0) {
#line 378 "rygel-audio-transcoder.c"
		guint _tmp11_ = 0U;
		RygelAudioItem* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp11_ = distance;
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp12_ = audio_item;
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp13_ = rygel_audio_item_get_bitrate (_tmp12_);
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp14_ = _tmp13_;
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp15_ = self->audio_bitrate;
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp16_ = abs (_tmp14_ - _tmp15_);
#line 93 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		distance = _tmp11_ + _tmp16_;
#line 399 "rygel-audio-transcoder.c"
	}
#line 96 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = distance;
#line 96 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_g_object_unref0 (audio_item);
#line 96 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 407 "rygel-audio-transcoder.c"
}


static GstEncodingProfile* rygel_audio_transcoder_real_get_encoding_profile (RygelGstTranscoder* base) {
	RygelAudioTranscoder * self;
	GstEncodingProfile* result = NULL;
	GstEncodingAudioProfile* enc_audio_profile = NULL;
	GstCaps* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GstEncodingAudioProfile* _tmp3_ = NULL;
	GstEncodingAudioProfile* _tmp4_ = NULL;
	GstCaps* _tmp5_ = NULL;
#line 99 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = (RygelAudioTranscoder*) base;
#line 100 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp0_ = self->audio_codec_format;
#line 100 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp1_ = rygel_gst_transcoder_get_preset ((RygelGstTranscoder*) self);
#line 100 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp2_ = _tmp1_;
#line 100 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp3_ = gst_encoding_audio_profile_new (_tmp0_, _tmp2_, NULL, (guint) 1);
#line 100 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	enc_audio_profile = _tmp3_;
#line 104 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp4_ = enc_audio_profile;
#line 104 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	gst_encoding_profile_set_name ((GstEncodingProfile*) _tmp4_, "audio");
#line 106 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_tmp5_ = self->container_format;
#line 106 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	if (_tmp5_ != NULL) {
#line 441 "rygel-audio-transcoder.c"
		GstEncodingContainerProfile* enc_container_profile = NULL;
		GstCaps* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GstEncodingContainerProfile* _tmp9_ = NULL;
		GstEncodingContainerProfile* _tmp10_ = NULL;
		GstEncodingAudioProfile* _tmp11_ = NULL;
		GstEncodingProfile* _tmp12_ = NULL;
#line 107 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp6_ = self->container_format;
#line 107 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp7_ = rygel_gst_transcoder_get_preset ((RygelGstTranscoder*) self);
#line 107 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp8_ = _tmp7_;
#line 107 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp9_ = gst_encoding_container_profile_new ("container", NULL, _tmp6_, _tmp8_);
#line 107 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		enc_container_profile = _tmp9_;
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp10_ = enc_container_profile;
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp11_ = enc_audio_profile;
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_tmp12_ = _g_object_ref0 ((GstEncodingProfile*) _tmp11_);
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		gst_encoding_container_profile_add_profile (_tmp10_, _tmp12_);
#line 113 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		result = (GstEncodingProfile*) enc_container_profile;
#line 113 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		_g_object_unref0 (enc_audio_profile);
#line 113 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
		return result;
#line 474 "rygel-audio-transcoder.c"
	}
#line 116 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	result = (GstEncodingProfile*) enc_audio_profile;
#line 116 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	return result;
#line 480 "rygel-audio-transcoder.c"
}


static void rygel_audio_transcoder_class_init (RygelAudioTranscoderClass * klass) {
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	rygel_audio_transcoder_parent_class = g_type_class_peek_parent (klass);
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	RYGEL_TRANSCODER_CLASS (klass)->add_resource = rygel_audio_transcoder_real_add_resource;
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	RYGEL_TRANSCODER_CLASS (klass)->get_distance = rygel_audio_transcoder_real_get_distance;
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	RYGEL_GST_TRANSCODER_CLASS (klass)->get_encoding_profile = rygel_audio_transcoder_real_get_encoding_profile;
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_audio_transcoder_finalize;
#line 495 "rygel-audio-transcoder.c"
}


static void rygel_audio_transcoder_instance_init (RygelAudioTranscoder * self) {
#line 32 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->container_format = NULL;
#line 33 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self->audio_codec_format = NULL;
#line 504 "rygel-audio-transcoder.c"
}


static void rygel_audio_transcoder_finalize (GObject* obj) {
	RygelAudioTranscoder * self;
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_AUDIO_TRANSCODER, RygelAudioTranscoder);
#line 32 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->container_format);
#line 33 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	_gst_caps_unref0 (self->audio_codec_format);
#line 30 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-audio-transcoder.vala"
	G_OBJECT_CLASS (rygel_audio_transcoder_parent_class)->finalize (obj);
#line 518 "rygel-audio-transcoder.c"
}


/**
 * Base class for all transcoders that handle audio.
 */
GType rygel_audio_transcoder_get_type (void) {
	static volatile gsize rygel_audio_transcoder_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_audio_transcoder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelAudioTranscoderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_audio_transcoder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelAudioTranscoder), 0, (GInstanceInitFunc) rygel_audio_transcoder_instance_init, NULL };
		GType rygel_audio_transcoder_type_id;
		rygel_audio_transcoder_type_id = g_type_register_static (RYGEL_TYPE_GST_TRANSCODER, "RygelAudioTranscoder", &g_define_type_info, 0);
		g_once_init_leave (&rygel_audio_transcoder_type_id__volatile, rygel_audio_transcoder_type_id);
	}
	return rygel_audio_transcoder_type_id__volatile;
}



