/* rygel-gst-sink.c generated by valac 0.22.0, the Vala compiler
 * generated from rygel-gst-sink.vala, do not modify */

/*
 * Copyright (C) 2011 Nokia Corporation.
 * Copyright (C) 2012 Intel Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *         Jens Georg <jensg@openismus.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/base/gstadapter.h>
#include <gst/base/gstbaseparse.h>
#include <gst/base/gstbasesink.h>
#include <gst/base/gstbasesrc.h>
#include <gst/base/gstbasetransform.h>
#include <gst/base/gstbitreader.h>
#include <gst/base/gstbytereader.h>
#include <gst/base/gstbytewriter.h>
#include <gst/base/gstcollectpads.h>
#include <gst/base/gstpushsrc.h>
#include <gst/base/gsttypefindhelper.h>
#include <gio/gio.h>
#include <rygel-server.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>


#define RYGEL_TYPE_GST_SINK (rygel_gst_sink_get_type ())
#define RYGEL_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_GST_SINK, RygelGstSink))
#define RYGEL_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))
#define RYGEL_IS_GST_SINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_GST_SINK))
#define RYGEL_IS_GST_SINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_GST_SINK))
#define RYGEL_GST_SINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_GST_SINK, RygelGstSinkClass))

typedef struct _RygelGstSink RygelGstSink;
typedef struct _RygelGstSinkClass RygelGstSinkClass;
typedef struct _RygelGstSinkPrivate RygelGstSinkPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gst_buffer_unref0(var) ((var == NULL) ? NULL : (var = (gst_buffer_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _gst_caps_unref0(var) ((var == NULL) ? NULL : (var = (gst_caps_unref (var), NULL)))

struct _RygelGstSink {
	GstBaseSink parent_instance;
	RygelGstSinkPrivate * priv;
	GCancellable* cancellable;
};

struct _RygelGstSinkClass {
	GstBaseSinkClass parent_class;
};

struct _RygelGstSinkPrivate {
	gint priority;
	gint64 bytes_sent;
	gint64 max_bytes;
	GMutex buffer_mutex;
	GCond buffer_condition;
	RygelDataSource* source;
	RygelHTTPSeek* offsets;
	gboolean frozen;
};

struct _Block1Data {
	int _ref_count_;
	RygelGstSink * self;
	GstBuffer* buffer;
};


static gpointer rygel_gst_sink_parent_class = NULL;

GType rygel_gst_sink_get_type (void) G_GNUC_CONST;
#define RYGEL_GST_SINK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_TYPE_GST_SINK, RygelGstSinkPrivate))
enum  {
	RYGEL_GST_SINK_DUMMY_PROPERTY
};
#define RYGEL_GST_SINK_NAME "http-gst-sink"
#define RYGEL_GST_SINK_PAD_NAME "sink"
#define RYGEL_GST_SINK_MAX_BUFFERED_CHUNKS ((guint) 32)
#define RYGEL_GST_SINK_MIN_BUFFERED_CHUNKS ((guint) 4)
RygelGstSink* rygel_gst_sink_new (RygelDataSource* source, RygelHTTPSeek* offsets);
RygelGstSink* rygel_gst_sink_construct (GType object_type, RygelDataSource* source, RygelHTTPSeek* offsets);
static void rygel_gst_sink_on_cancelled (RygelGstSink* self);
static void _rygel_gst_sink_on_cancelled_g_cancellable_cancelled (GCancellable* _sender, gpointer self);
void rygel_gst_sink_freeze (RygelGstSink* self);
void rygel_gst_sink_thaw (RygelGstSink* self);
static GstFlowReturn rygel_gst_sink_real_render (GstBaseSink* base, GstBuffer* buffer);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda2_ (Block1Data* _data1_);
gboolean rygel_gst_sink_push_data (RygelGstSink* self, GstBuffer* buffer);
static gboolean ___lambda2__gsource_func (gpointer self);
static void rygel_gst_sink_finalize (GObject* obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);


static gpointer _g_object_ref0 (gpointer self) {
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self ? g_object_ref (self) : NULL;
#line 126 "rygel-gst-sink.c"
}


static void _rygel_gst_sink_on_cancelled_g_cancellable_cancelled (GCancellable* _sender, gpointer self) {
#line 77 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	rygel_gst_sink_on_cancelled (self);
#line 133 "rygel-gst-sink.c"
}


RygelGstSink* rygel_gst_sink_construct (GType object_type, RygelDataSource* source, RygelHTTPSeek* offsets) {
	RygelGstSink * self = NULL;
	gint64 _tmp0_ = 0LL;
	RygelDataSource* _tmp1_ = NULL;
	RygelHTTPSeek* _tmp2_ = NULL;
	RygelHTTPSeek* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
	RygelHTTPSeek* _tmp5_ = NULL;
	GCancellable* _tmp12_ = NULL;
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = (RygelGstSink*) g_object_new (object_type, NULL);
#line 60 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->bytes_sent = (gint64) 0;
#line 61 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = G_MAXINT64;
#line 61 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->max_bytes = _tmp0_;
#line 62 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = source;
#line 62 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->source = _tmp1_;
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp2_ = offsets;
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->priv->offsets);
#line 63 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->offsets = _tmp3_;
#line 65 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp4_ = g_cancellable_new ();
#line 65 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->cancellable);
#line 65 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->cancellable = _tmp4_;
#line 67 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_base_sink_set_sync ((GstBaseSink*) self, FALSE);
#line 68 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_object_set ((GstObject*) self, "name", RYGEL_GST_SINK_NAME, NULL);
#line 69 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->frozen = FALSE;
#line 71 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp5_ = self->priv->offsets;
#line 71 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp5_ != NULL) {
#line 184 "rygel-gst-sink.c"
		RygelHTTPSeek* _tmp6_ = NULL;
		RygelHTTPSeekType _tmp7_ = 0;
		RygelHTTPSeekType _tmp8_ = 0;
#line 72 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp6_ = self->priv->offsets;
#line 72 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp7_ = rygel_http_seek_get_seek_type (_tmp6_);
#line 72 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp8_ = _tmp7_;
#line 72 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (_tmp8_ == RYGEL_HTTP_SEEK_TYPE_BYTE) {
#line 196 "rygel-gst-sink.c"
			RygelHTTPSeek* _tmp9_ = NULL;
			gint64 _tmp10_ = 0LL;
			gint64 _tmp11_ = 0LL;
#line 73 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp9_ = self->priv->offsets;
#line 73 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp10_ = rygel_http_seek_get_length (_tmp9_);
#line 73 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp11_ = _tmp10_;
#line 73 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			self->priv->max_bytes = _tmp11_;
#line 208 "rygel-gst-sink.c"
		}
	}
#line 77 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp12_ = self->cancellable;
#line 77 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_signal_connect_object (_tmp12_, "cancelled", (GCallback) _rygel_gst_sink_on_cancelled_g_cancellable_cancelled, self, 0);
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self;
#line 217 "rygel-gst-sink.c"
}


RygelGstSink* rygel_gst_sink_new (RygelDataSource* source, RygelHTTPSeek* offsets) {
#line 59 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return rygel_gst_sink_construct (RYGEL_TYPE_GST_SINK, source, offsets);
#line 224 "rygel-gst-sink.c"
}


void rygel_gst_sink_freeze (RygelGstSink* self) {
	gboolean _tmp0_ = FALSE;
#line 80 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 81 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = self->priv->frozen;
#line 81 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp0_) {
#line 82 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		return;
#line 238 "rygel-gst-sink.c"
	}
#line 85 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 86 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->frozen = TRUE;
#line 87 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 246 "rygel-gst-sink.c"
}


void rygel_gst_sink_thaw (RygelGstSink* self) {
	gboolean _tmp0_ = FALSE;
#line 90 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 91 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = self->priv->frozen;
#line 91 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (!_tmp0_) {
#line 92 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		return;
#line 260 "rygel-gst-sink.c"
	}
#line 95 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 96 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->frozen = FALSE;
#line 97 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_cond_broadcast (&self->priv->buffer_condition);
#line 98 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 270 "rygel-gst-sink.c"
}


static gpointer _gst_buffer_ref0 (gpointer self) {
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return self ? gst_buffer_ref (self) : NULL;
#line 277 "rygel-gst-sink.c"
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return _data1_;
#line 286 "rygel-gst-sink.c"
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 295 "rygel-gst-sink.c"
		RygelGstSink * self;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		self = _data1_->self;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_gst_buffer_unref0 (_data1_->buffer);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_g_object_unref0 (self);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		g_slice_free (Block1Data, _data1_);
#line 305 "rygel-gst-sink.c"
	}
}


static gboolean __lambda2_ (Block1Data* _data1_) {
	RygelGstSink * self;
	gboolean result = FALSE;
	GstBuffer* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 114 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = _data1_->self;
#line 115 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = _data1_->buffer;
#line 115 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = rygel_gst_sink_push_data (self, _tmp0_);
#line 115 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = _tmp1_;
#line 115 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 325 "rygel-gst-sink.c"
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
#line 114 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 334 "rygel-gst-sink.c"
}


static GstFlowReturn rygel_gst_sink_real_render (GstBaseSink* base, GstBuffer* buffer) {
	RygelGstSink * self;
	GstFlowReturn result = 0;
	Block1Data* _data1_;
	GstBuffer* _tmp0_ = NULL;
	GstBuffer* _tmp1_ = NULL;
	GCancellable* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_ = 0;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = (RygelGstSink*) base;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (buffer != NULL, 0);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data1_->_ref_count_ = 1;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data1_->self = g_object_ref (self);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = buffer;
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = _gst_buffer_ref0 (_tmp0_);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_gst_buffer_unref0 (_data1_->buffer);
#line 101 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data1_->buffer = _tmp1_;
#line 102 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	while (TRUE) {
#line 369 "rygel-gst-sink.c"
		gboolean _tmp2_ = FALSE;
		GCancellable* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp6_ = FALSE;
		GMutex _tmp7_ = {0};
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp3_ = self->cancellable;
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp4_ = g_cancellable_is_cancelled (_tmp3_);
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (!_tmp4_) {
#line 381 "rygel-gst-sink.c"
			gboolean _tmp5_ = FALSE;
#line 104 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp5_ = self->priv->frozen;
#line 104 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp2_ = _tmp5_;
#line 387 "rygel-gst-sink.c"
		} else {
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			_tmp2_ = FALSE;
#line 391 "rygel-gst-sink.c"
		}
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp6_ = _tmp2_;
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		if (!_tmp6_) {
#line 103 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
			break;
#line 399 "rygel-gst-sink.c"
		}
#line 106 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp7_ = self->priv->buffer_mutex;
#line 106 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		g_cond_wait (&self->priv->buffer_condition, &_tmp7_);
#line 405 "rygel-gst-sink.c"
	}
#line 108 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 110 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp8_ = self->cancellable;
#line 110 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp9_ = g_cancellable_is_cancelled (_tmp8_);
#line 110 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp9_) {
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		result = GST_FLOW_OK;
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		block1_data_unref (_data1_);
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_data1_ = NULL;
#line 111 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		return result;
#line 423 "rygel-gst-sink.c"
	}
#line 114 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp10_ = self->priv->priority;
#line 114 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_idle_add_full (_tmp10_, ___lambda2__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 118 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = GST_FLOW_OK;
#line 118 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	block1_data_unref (_data1_);
#line 118 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_data1_ = NULL;
#line 118 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 437 "rygel-gst-sink.c"
}


gboolean rygel_gst_sink_push_data (RygelGstSink* self, GstBuffer* buffer) {
	gboolean result = FALSE;
	gint64 left = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp1_ = 0LL;
	gboolean _tmp2_ = FALSE;
	GCancellable* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gsize bufsize = 0UL;
	GstBuffer* _tmp7_ = NULL;
	gsize _tmp8_ = 0UL;
	gint64 to_send = 0LL;
	gsize _tmp9_ = 0UL;
	gint64 _tmp10_ = 0LL;
	gint64 _tmp11_ = 0LL;
	GstMapInfo info = {0};
	GstBuffer* _tmp12_ = NULL;
	GstMapInfo _tmp13_ = {0};
	guint8* tmp = NULL;
	GstMapInfo _tmp14_ = {0};
	guint8* _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gint64 _tmp16_ = 0LL;
	gint tmp_length1 = 0;
	gint _tmp_size_ = 0;
	RygelDataSource* _tmp17_ = NULL;
	guint8* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	gint64 _tmp19_ = 0LL;
	gint64 _tmp20_ = 0LL;
	GstBuffer* _tmp21_ = NULL;
	GstMapInfo _tmp22_ = {0};
#line 122 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 122 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_val_if_fail (buffer != NULL, FALSE);
#line 123 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = self->priv->max_bytes;
#line 123 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = self->priv->bytes_sent;
#line 123 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	left = _tmp0_ - _tmp1_;
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = self->cancellable;
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp4_ = g_cancellable_is_cancelled (_tmp3_);
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp4_) {
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp2_ = TRUE;
#line 492 "rygel-gst-sink.c"
	} else {
		gint64 _tmp5_ = 0LL;
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp5_ = left;
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		_tmp2_ = _tmp5_ <= ((gint64) 0);
#line 499 "rygel-gst-sink.c"
	}
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp6_ = _tmp2_;
#line 125 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	if (_tmp6_) {
#line 126 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		result = FALSE;
#line 126 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
		return result;
#line 509 "rygel-gst-sink.c"
	}
#line 129 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp7_ = buffer;
#line 129 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp8_ = gst_buffer_get_size (_tmp7_);
#line 129 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	bufsize = _tmp8_;
#line 130 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp9_ = bufsize;
#line 130 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp10_ = left;
#line 130 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp11_ = MIN ((gint64) _tmp9_, _tmp10_);
#line 130 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	to_send = _tmp11_;
#line 133 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp12_ = buffer;
#line 133 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_buffer_map (_tmp12_, &_tmp13_, GST_MAP_READ);
#line 133 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	info = _tmp13_;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp14_ = info;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp15_ = _tmp14_.data;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp15__length1 = (gint) _tmp14_.size;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp16_ = to_send;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	tmp = _tmp15_ + 0;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	tmp_length1 = ((gint) _tmp16_) - 0;
#line 135 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp_size_ = tmp_length1;
#line 137 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp17_ = self->priv->source;
#line 137 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp18_ = tmp;
#line 137 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp18__length1 = tmp_length1;
#line 137 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_signal_emit_by_name (_tmp17_, "data-available", _tmp18_, _tmp18__length1);
#line 138 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp19_ = self->priv->bytes_sent;
#line 138 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp20_ = to_send;
#line 138 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->bytes_sent = _tmp19_ + _tmp20_;
#line 139 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp21_ = buffer;
#line 139 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp22_ = info;
#line 139 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_buffer_unmap (_tmp21_, &_tmp22_);
#line 141 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	result = FALSE;
#line 141 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	return result;
#line 569 "rygel-gst-sink.c"
}


static void rygel_gst_sink_on_cancelled (RygelGstSink* self) {
#line 144 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_return_if_fail (self != NULL);
#line 145 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_lock (&self->priv->buffer_mutex);
#line 146 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_cond_broadcast (&self->priv->buffer_condition);
#line 147 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_unlock (&self->priv->buffer_mutex);
#line 582 "rygel-gst-sink.c"
}


static void rygel_gst_sink_class_init (RygelGstSinkClass * klass) {
	GstCaps* caps = NULL;
	GstCaps* _tmp0_ = NULL;
	GstPadTemplate* template = NULL;
	GstCaps* _tmp1_ = NULL;
	GstPadTemplate* _tmp2_ = NULL;
	GstPadTemplate* _tmp3_ = NULL;
	GstPadTemplate* _tmp4_ = NULL;
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	rygel_gst_sink_parent_class = g_type_class_peek_parent (klass);
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_type_class_add_private (klass, sizeof (RygelGstSinkPrivate));
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	GST_BASE_SINK_CLASS (klass)->render = rygel_gst_sink_real_render;
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_gst_sink_finalize;
#line 51 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp0_ = gst_caps_new_any ();
#line 51 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	caps = _tmp0_;
#line 52 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp1_ = caps;
#line 52 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp2_ = gst_pad_template_new (RYGEL_GST_SINK_PAD_NAME, GST_PAD_SINK, GST_PAD_ALWAYS, _tmp1_);
#line 52 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_object_ref_sink (_tmp2_);
#line 52 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	template = _tmp2_;
#line 56 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp3_ = template;
#line 56 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 56 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	gst_element_class_add_pad_template (GST_ELEMENT_CLASS (klass), _tmp4_);
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (template);
#line 50 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_gst_caps_unref0 (caps);
#line 624 "rygel-gst-sink.c"
}


static void rygel_gst_sink_instance_init (RygelGstSink * self) {
	GMutex _tmp0_ = {0};
	GCond _tmp1_ = {0};
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv = RYGEL_GST_SINK_GET_PRIVATE (self);
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_mutex_init (&_tmp0_);
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->buffer_mutex = _tmp0_;
#line 44 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	g_cond_init (&_tmp1_);
#line 44 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self->priv->buffer_condition = _tmp1_;
#line 641 "rygel-gst-sink.c"
}


static void rygel_gst_sink_finalize (GObject* obj) {
	RygelGstSink * self;
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_GST_SINK, RygelGstSink);
#line 36 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->cancellable);
#line 43 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_vala_clear_GMutex (&self->priv->buffer_mutex);
#line 44 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_vala_clear_GCond (&self->priv->buffer_condition);
#line 46 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	_g_object_unref0 (self->priv->offsets);
#line 29 "/home/jens/Source/rygel/src/media-engines/gstreamer/rygel-gst-sink.vala"
	G_OBJECT_CLASS (rygel_gst_sink_parent_class)->finalize (obj);
#line 659 "rygel-gst-sink.c"
}


GType rygel_gst_sink_get_type (void) {
	static volatile gsize rygel_gst_sink_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_gst_sink_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelGstSinkClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_gst_sink_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelGstSink), 0, (GInstanceInitFunc) rygel_gst_sink_instance_init, NULL };
		GType rygel_gst_sink_type_id;
		rygel_gst_sink_type_id = g_type_register_static (gst_base_sink_get_type (), "RygelGstSink", &g_define_type_info, 0);
		g_once_init_leave (&rygel_gst_sink_type_id__volatile, rygel_gst_sink_type_id);
	}
	return rygel_gst_sink_type_id__volatile;
}


static void _vala_clear_GMutex (GMutex * mutex) {
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}


static void _vala_clear_GRecMutex (GRecMutex * mutex) {
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}


static void _vala_clear_GRWLock (GRWLock * mutex) {
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}


static void _vala_clear_GCond (GCond * mutex) {
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}



