/* rygel-media-export-metadata-extractor.c generated by valac 0.22.0, the Vala compiler
 * generated from rygel-media-export-metadata-extractor.vala, do not modify */

/*
 * Copyright (C) 2008 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 * Copyright (C) 2009 Jens Georg <mail@jensge.org>.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gst/pbutils/codec-utils.h>
#include <gst/pbutils/descriptions.h>
#include <gst/pbutils/encoding-profile.h>
#include <gst/pbutils/encoding-target.h>
#include <gst/pbutils/gstdiscoverer.h>
#include <gst/pbutils/gstpluginsbaseversion.h>
#include <gst/pbutils/install-plugins.h>
#include <gst/pbutils/missing-plugins.h>
#include <gst/pbutils/pbutils-enumtypes.h>
#include <gst/pbutils/pbutils.h>
#include <libgupnp-dlna/gupnp-dlna.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <rygel-core.h>
#include <gst/gst.h>
#include <libgupnp-dlna/gupnp-dlna-gst-utils.h>
#include <glib/gi18n-lib.h>


#define RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR (rygel_media_export_metadata_extractor_get_type ())
#define RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, RygelMediaExportMetadataExtractor))
#define RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, RygelMediaExportMetadataExtractorClass))
#define RYGEL_MEDIA_EXPORT_IS_METADATA_EXTRACTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_IS_METADATA_EXTRACTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR))
#define RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, RygelMediaExportMetadataExtractorClass))

typedef struct _RygelMediaExportMetadataExtractor RygelMediaExportMetadataExtractor;
typedef struct _RygelMediaExportMetadataExtractorClass RygelMediaExportMetadataExtractorClass;
typedef struct _RygelMediaExportMetadataExtractorPrivate RygelMediaExportMetadataExtractorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelMediaExportMetadataExtractor {
	GObject parent_instance;
	RygelMediaExportMetadataExtractorPrivate * priv;
};

struct _RygelMediaExportMetadataExtractorClass {
	GObjectClass parent_class;
};

struct _RygelMediaExportMetadataExtractorPrivate {
	GstDiscoverer* discoverer;
	GUPnPDLNAProfileGuesser* guesser;
	GeeHashMap* file_hash;
	guint timeout;
	gboolean extract_metadata;
};


static gpointer rygel_media_export_metadata_extractor_parent_class = NULL;

GType rygel_media_export_metadata_extractor_get_type (void) G_GNUC_CONST;
#define RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, RygelMediaExportMetadataExtractorPrivate))
enum  {
	RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR_DUMMY_PROPERTY
};
RygelMediaExportMetadataExtractor* rygel_media_export_metadata_extractor_new (void);
RygelMediaExportMetadataExtractor* rygel_media_export_metadata_extractor_construct (GType object_type);
static void rygel_media_export_metadata_extractor_on_config_changed (RygelMediaExportMetadataExtractor* self, RygelConfiguration* config, const gchar* section, const gchar* key);
static void _rygel_media_export_metadata_extractor_on_config_changed_rygel_configuration_setting_changed (RygelConfiguration* _sender, const gchar* section, const gchar* key, gpointer self);
#define RYGEL_MEDIA_EXPORT_PLUGIN_NAME "MediaExport"
void rygel_media_export_metadata_extractor_extract (RygelMediaExportMetadataExtractor* self, GFile* file, const gchar* content_type);
static void rygel_media_export_metadata_extractor_extract_basic_information (RygelMediaExportMetadataExtractor* self, GFile* file, GstDiscovererInfo* info, GUPnPDLNAProfile* dlna);
static void rygel_media_export_metadata_extractor_on_done (RygelMediaExportMetadataExtractor* self, GstDiscovererInfo* info, GError* err);
static void _rygel_media_export_metadata_extractor_on_done_gst_pb_utils_discoverer_discovered (GstDiscoverer* _sender, GstDiscovererInfo* info, GError* err, gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void rygel_media_export_metadata_extractor_finalize (GObject* obj);


static void _rygel_media_export_metadata_extractor_on_config_changed_rygel_configuration_setting_changed (RygelConfiguration* _sender, const gchar* section, const gchar* key, gpointer self) {
#line 66 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	rygel_media_export_metadata_extractor_on_config_changed (self, _sender, section, key);
#line 108 "rygel-media-export-metadata-extractor.c"
}


RygelMediaExportMetadataExtractor* rygel_media_export_metadata_extractor_construct (GType object_type) {
	RygelMediaExportMetadataExtractor * self = NULL;
	GeeHashMap* _tmp0_ = NULL;
	RygelMetaConfig* config = NULL;
	RygelMetaConfig* _tmp1_ = NULL;
#line 62 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self = (RygelMediaExportMetadataExtractor*) g_object_new (object_type, NULL);
#line 63 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 63 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (self->priv->file_hash);
#line 63 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self->priv->file_hash = _tmp0_;
#line 65 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp1_ = rygel_meta_config_get_default ();
#line 65 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	config = _tmp1_;
#line 66 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_signal_connect_object ((RygelConfiguration*) config, "setting-changed", (GCallback) _rygel_media_export_metadata_extractor_on_config_changed_rygel_configuration_setting_changed, self, 0);
#line 67 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	rygel_media_export_metadata_extractor_on_config_changed (self, (RygelConfiguration*) config, RYGEL_MEDIA_EXPORT_PLUGIN_NAME, "extract-metadata");
#line 62 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (config);
#line 62 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	return self;
#line 137 "rygel-media-export-metadata-extractor.c"
}


RygelMediaExportMetadataExtractor* rygel_media_export_metadata_extractor_new (void) {
#line 62 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	return rygel_media_export_metadata_extractor_construct (RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR);
#line 144 "rygel-media-export-metadata-extractor.c"
}


static void _rygel_media_export_metadata_extractor_on_done_gst_pb_utils_discoverer_discovered (GstDiscoverer* _sender, GstDiscovererInfo* info, GError* err, gpointer self) {
#line 84 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	rygel_media_export_metadata_extractor_on_done (self, info, err);
#line 151 "rygel-media-export-metadata-extractor.c"
}


void rygel_media_export_metadata_extractor_extract (RygelMediaExportMetadataExtractor* self, GFile* file, const gchar* content_type) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GError * _inner_error_ = NULL;
#line 70 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (self != NULL);
#line 70 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (file != NULL);
#line 70 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (content_type != NULL);
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp1_ = self->priv->extract_metadata;
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_tmp1_) {
#line 170 "rygel-media-export-metadata-extractor.c"
		const gchar* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp2_ = content_type;
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp3_ = g_str_has_prefix (_tmp2_, "text/");
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp0_ = !_tmp3_;
#line 179 "rygel-media-export-metadata-extractor.c"
	} else {
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp0_ = FALSE;
#line 183 "rygel-media-export-metadata-extractor.c"
	}
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp4_ = _tmp0_;
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_tmp4_) {
#line 189 "rygel-media-export-metadata-extractor.c"
		gchar* uri = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		GeeHashMap* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		GFile* _tmp14_ = NULL;
		GstDiscoverer* _tmp15_ = NULL;
		GstDiscoverer* _tmp16_ = NULL;
		GstDiscoverer* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		GUPnPDLNAProfileGuesser* _tmp19_ = NULL;
#line 72 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp5_ = file;
#line 72 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp6_ = g_file_get_uri (_tmp5_);
#line 72 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		uri = _tmp6_;
#line 207 "rygel-media-export-metadata-extractor.c"
		{
			GstClockTime gst_timeout = 0ULL;
			guint _tmp7_ = 0U;
			GstDiscoverer* _tmp8_ = NULL;
			GstClockTime _tmp9_ = 0ULL;
			GstDiscoverer* _tmp10_ = NULL;
#line 74 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp7_ = self->priv->timeout;
#line 74 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			gst_timeout = (GstClockTime) (_tmp7_ * GST_SECOND);
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp9_ = gst_timeout;
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp10_ = gst_discoverer_new (_tmp9_, &_inner_error_);
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp8_ = _tmp10_;
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			if (_inner_error_ != NULL) {
#line 226 "rygel-media-export-metadata-extractor.c"
				goto __catch36_g_error;
			}
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_g_object_unref0 (self->priv->discoverer);
#line 76 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			self->priv->discoverer = _tmp8_;
#line 233 "rygel-media-export-metadata-extractor.c"
		}
		goto __finally36;
		__catch36_g_error:
		{
			GError* _error_ = NULL;
			GFile* _tmp11_ = NULL;
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_error_ = _inner_error_;
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_inner_error_ = NULL;
#line 78 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			g_debug ("rygel-media-export-metadata-extractor.vala:78: Failed to create a disc" \
"overer. Doing basic extraction.");
#line 79 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp11_ = file;
#line 79 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			rygel_media_export_metadata_extractor_extract_basic_information (self, _tmp11_, NULL, NULL);
#line 81 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_g_error_free0 (_error_);
#line 81 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_g_free0 (uri);
#line 81 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			return;
#line 256 "rygel-media-export-metadata-extractor.c"
		}
		__finally36:
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		if (_inner_error_ != NULL) {
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_g_free0 (uri);
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			g_clear_error (&_inner_error_);
#line 73 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			return;
#line 269 "rygel-media-export-metadata-extractor.c"
		}
#line 83 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp12_ = self->priv->file_hash;
#line 83 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp13_ = uri;
#line 83 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp14_ = file;
#line 83 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp14_);
#line 84 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp15_ = self->priv->discoverer;
#line 84 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_signal_connect_object (_tmp15_, "discovered", (GCallback) _rygel_media_export_metadata_extractor_on_done_gst_pb_utils_discoverer_discovered, self, 0);
#line 85 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp16_ = self->priv->discoverer;
#line 85 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		gst_discoverer_start (_tmp16_);
#line 86 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp17_ = self->priv->discoverer;
#line 86 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp18_ = uri;
#line 86 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		gst_discoverer_discover_uri_async (_tmp17_, _tmp18_);
#line 87 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp19_ = gupnp_dlna_profile_guesser_new (TRUE, TRUE);
#line 87 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (self->priv->guesser);
#line 87 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		self->priv->guesser = _tmp19_;
#line 71 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_free0 (uri);
#line 301 "rygel-media-export-metadata-extractor.c"
	} else {
		GFile* _tmp20_ = NULL;
#line 89 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp20_ = file;
#line 89 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		rygel_media_export_metadata_extractor_extract_basic_information (self, _tmp20_, NULL, NULL);
#line 308 "rygel-media-export-metadata-extractor.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	return self ? g_object_ref (self) : NULL;
#line 316 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_on_done (RygelMediaExportMetadataExtractor* self, GstDiscovererInfo* info, GError* err) {
	GFile* file = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GstDiscovererInfo* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gpointer _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GeeHashMap* _tmp7_ = NULL;
	GstDiscovererInfo* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	GstDiscovererInfo* _tmp10_ = NULL;
	GstDiscovererResult _tmp11_ = 0;
	GUPnPDLNAInformation* dlna_info = NULL;
	GstDiscovererInfo* _tmp20_ = NULL;
	GUPnPDLNAInformation* _tmp21_ = NULL;
	GUPnPDLNAProfile* dlna = NULL;
	GUPnPDLNAProfileGuesser* _tmp22_ = NULL;
	GUPnPDLNAInformation* _tmp23_ = NULL;
	GUPnPDLNAProfile* _tmp24_ = NULL;
	GUPnPDLNAProfile* _tmp25_ = NULL;
	GFile* _tmp26_ = NULL;
	GstDiscovererInfo* _tmp27_ = NULL;
	GUPnPDLNAProfile* _tmp28_ = NULL;
#line 93 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (self != NULL);
#line 93 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (info != NULL);
#line 94 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (self->priv->discoverer);
#line 94 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self->priv->discoverer = NULL;
#line 95 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp0_ = self->priv->file_hash;
#line 95 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp1_ = info;
#line 95 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp2_ = gst_discoverer_info_get_uri (_tmp1_);
#line 95 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 95 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	file = (GFile*) _tmp3_;
#line 96 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp4_ = file;
#line 96 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_tmp4_ == NULL) {
#line 365 "rygel-media-export-metadata-extractor.c"
		GstDiscovererInfo* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 97 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp5_ = info;
#line 97 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp6_ = gst_discoverer_info_get_uri (_tmp5_);
#line 97 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_warning ("rygel-media-export-metadata-extractor.vala:97: File %s already handled" \
", ignoring event", _tmp6_);
#line 100 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (file);
#line 100 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 378 "rygel-media-export-metadata-extractor.c"
	}
#line 103 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp7_ = self->priv->file_hash;
#line 103 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp8_ = info;
#line 103 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp9_ = gst_discoverer_info_get_uri (_tmp8_);
#line 103 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp7_, _tmp9_, NULL);
#line 105 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp10_ = info;
#line 105 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp11_ = gst_discoverer_info_get_result (_tmp10_);
#line 105 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if ((_tmp11_ & GST_DISCOVERER_TIMEOUT) != 0) {
#line 394 "rygel-media-export-metadata-extractor.c"
		GFile* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GFile* _tmp15_ = NULL;
#line 106 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp12_ = file;
#line 106 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp13_ = g_file_get_uri (_tmp12_);
#line 106 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp14_ = _tmp13_;
#line 106 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_debug ("rygel-media-export-metadata-extractor.vala:106: Extraction timed out o" \
"n %s", _tmp14_);
#line 106 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_free0 (_tmp14_);
#line 107 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp15_ = file;
#line 107 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		rygel_media_export_metadata_extractor_extract_basic_information (self, _tmp15_, NULL, NULL);
#line 109 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (file);
#line 109 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 417 "rygel-media-export-metadata-extractor.c"
	} else {
		GstDiscovererInfo* _tmp16_ = NULL;
		GstDiscovererResult _tmp17_ = 0;
#line 110 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp16_ = info;
#line 110 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp17_ = gst_discoverer_info_get_result (_tmp16_);
#line 110 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		if ((_tmp17_ & GST_DISCOVERER_ERROR) != 0) {
#line 427 "rygel-media-export-metadata-extractor.c"
			GFile* _tmp18_ = NULL;
			GError* _tmp19_ = NULL;
#line 112 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp18_ = file;
#line 112 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_tmp19_ = err;
#line 112 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			g_signal_emit_by_name (self, "error", _tmp18_, _tmp19_);
#line 114 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			_g_object_unref0 (file);
#line 114 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
			return;
#line 440 "rygel-media-export-metadata-extractor.c"
		}
	}
#line 117 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp20_ = info;
#line 117 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp21_ = gupnp_dlna_gst_utils_information_from_discoverer_info (_tmp20_);
#line 117 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	dlna_info = _tmp21_;
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp22_ = self->priv->guesser;
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp23_ = dlna_info;
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp24_ = gupnp_dlna_profile_guesser_guess_profile_from_info (_tmp22_, _tmp23_);
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 118 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	dlna = _tmp25_;
#line 119 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp26_ = file;
#line 119 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp27_ = info;
#line 119 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp28_ = dlna;
#line 119 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	rygel_media_export_metadata_extractor_extract_basic_information (self, _tmp26_, _tmp27_, _tmp28_);
#line 93 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (dlna);
#line 93 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (dlna_info);
#line 93 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (file);
#line 473 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_extract_basic_information (RygelMediaExportMetadataExtractor* self, GFile* file, GstDiscovererInfo* info, GUPnPDLNAProfile* dlna) {
	GFileInfo* file_info = NULL;
	GFile* _tmp12_ = NULL;
	GstDiscovererInfo* _tmp13_ = NULL;
	GUPnPDLNAProfile* _tmp14_ = NULL;
	GFileInfo* _tmp15_ = NULL;
	GError * _inner_error_ = NULL;
#line 122 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (self != NULL);
#line 122 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (file != NULL);
#line 488 "rygel-media-export-metadata-extractor.c"
	{
		GFileInfo* _tmp0_ = NULL;
		GFile* _tmp1_ = NULL;
		GFileInfo* _tmp2_ = NULL;
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp1_ = file;
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp2_ = g_file_query_info (_tmp1_, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_TIME_MODIFIED "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp0_ = _tmp2_;
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		if (_inner_error_ != NULL) {
#line 501 "rygel-media-export-metadata-extractor.c"
			goto __catch37_g_error;
		}
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (file_info);
#line 128 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		file_info = _tmp0_;
#line 508 "rygel-media-export-metadata-extractor.c"
	}
	goto __finally37;
	__catch37_g_error:
	{
		GError* _error_ = NULL;
		gchar* uri = NULL;
		GFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_error_ = _inner_error_;
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_inner_error_ = NULL;
#line 136 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp3_ = file;
#line 136 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp4_ = g_file_get_uri (_tmp3_);
#line 136 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		uri = _tmp4_;
#line 138 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp5_ = _ ("Failed to query content type for '%s'");
#line 138 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp6_ = uri;
#line 138 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_warning (_tmp5_, _tmp6_);
#line 140 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp7_ = uri;
#line 140 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp8_ = _error_;
#line 140 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp9_ = _tmp8_->message;
#line 140 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_debug ("rygel-media-export-metadata-extractor.vala:140: Failed to extract basi" \
"c metadata from %s: %s", _tmp7_, _tmp9_);
#line 145 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp10_ = file;
#line 145 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp11_ = _error_;
#line 145 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_signal_emit_by_name (self, "error", _tmp10_, _tmp11_);
#line 146 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_free0 (uri);
#line 146 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_error_free0 (_error_);
#line 146 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (file_info);
#line 146 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 562 "rygel-media-export-metadata-extractor.c"
	}
	__finally37:
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_inner_error_ != NULL) {
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_object_unref0 (file_info);
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_clear_error (&_inner_error_);
#line 127 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 575 "rygel-media-export-metadata-extractor.c"
	}
#line 149 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp12_ = file;
#line 149 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp13_ = info;
#line 149 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp14_ = dlna;
#line 149 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp15_ = file_info;
#line 149 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_signal_emit_by_name (self, "extraction-done", _tmp12_, _tmp13_, _tmp14_, _tmp15_);
#line 122 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (file_info);
#line 589 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_on_config_changed (RygelMediaExportMetadataExtractor* self, RygelConfiguration* config, const gchar* section, const gchar* key) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
#line 155 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (self != NULL);
#line 155 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (config != NULL);
#line 155 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (section != NULL);
#line 155 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (key != NULL);
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp1_ = section;
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (g_strcmp0 (_tmp1_, RYGEL_MEDIA_EXPORT_PLUGIN_NAME) != 0) {
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp0_ = TRUE;
#line 612 "rygel-media-export-metadata-extractor.c"
	} else {
		const gchar* _tmp2_ = NULL;
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp2_ = key;
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, "extract-metadata") != 0;
#line 619 "rygel-media-export-metadata-extractor.c"
	}
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_tmp3_ = _tmp0_;
#line 158 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_tmp3_) {
#line 159 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 627 "rygel-media-export-metadata-extractor.c"
	}
	{
		gboolean _tmp4_ = FALSE;
		RygelConfiguration* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 163 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp5_ = config;
#line 163 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp6_ = rygel_configuration_get_bool (_tmp5_, RYGEL_MEDIA_EXPORT_PLUGIN_NAME, "extract-metadata", &_inner_error_);
#line 163 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_tmp4_ = _tmp6_;
#line 163 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		if (_inner_error_ != NULL) {
#line 641 "rygel-media-export-metadata-extractor.c"
			goto __catch38_g_error;
		}
#line 163 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		self->priv->extract_metadata = _tmp4_;
#line 646 "rygel-media-export-metadata-extractor.c"
	}
	goto __finally38;
	__catch38_g_error:
	{
		GError* _error_ = NULL;
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_error_ = _inner_error_;
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_inner_error_ = NULL;
#line 166 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		self->priv->extract_metadata = TRUE;
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		_g_error_free0 (_error_);
#line 660 "rygel-media-export-metadata-extractor.c"
	}
	__finally38:
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (_inner_error_ != NULL) {
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		g_clear_error (&_inner_error_);
#line 162 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		return;
#line 671 "rygel-media-export-metadata-extractor.c"
	}
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (n_param_values == 5);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data1 = closure->data;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data2 = param_values->data[0].v_pointer;
#line 691 "rygel-media-export-metadata-extractor.c"
	} else {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data2 = closure->data;
#line 697 "rygel-media-export-metadata-extractor.c"
	}
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), g_value_get_object (param_values + 4), data2);
#line 703 "rygel-media-export-metadata-extractor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data1 = closure->data;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data2 = param_values->data[0].v_pointer;
#line 722 "rygel-media-export-metadata-extractor.c"
	} else {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
		data2 = closure->data;
#line 728 "rygel-media-export-metadata-extractor.c"
	}
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 734 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_class_init (RygelMediaExportMetadataExtractorClass * klass) {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	rygel_media_export_metadata_extractor_parent_class = g_type_class_peek_parent (klass);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_type_class_add_private (klass, sizeof (RygelMediaExportMetadataExtractorPrivate));
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_media_export_metadata_extractor_finalize;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_signal_new ("extraction_done", RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 4, G_TYPE_FILE, gst_discoverer_info_get_type (), gupnp_dlna_profile_get_type (), g_file_info_get_type ());
#line 747 "rygel-media-export-metadata-extractor.c"
	/**
	     * Signalize that an error occured during metadata extraction
	     */
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	g_signal_new ("error", RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_POINTER, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_POINTER);
#line 753 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_instance_init (RygelMediaExportMetadataExtractor * self) {
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self->priv = RYGEL_MEDIA_EXPORT_METADATA_EXTRACTOR_GET_PRIVATE (self);
#line 58 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self->priv->timeout = (guint) 10;
#line 762 "rygel-media-export-metadata-extractor.c"
}


static void rygel_media_export_metadata_extractor_finalize (GObject* obj) {
	RygelMediaExportMetadataExtractor * self;
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_MEDIA_EXPORT_TYPE_METADATA_EXTRACTOR, RygelMediaExportMetadataExtractor);
#line 49 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (self->priv->discoverer);
#line 50 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (self->priv->guesser);
#line 57 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	_g_object_unref0 (self->priv->file_hash);
#line 37 "/home/jens/Source/rygel/src/plugins/media-export/rygel-media-export-metadata-extractor.vala"
	G_OBJECT_CLASS (rygel_media_export_metadata_extractor_parent_class)->finalize (obj);
#line 778 "rygel-media-export-metadata-extractor.c"
}


/**
 * Metadata extractor based on Gstreamer. Just set the URI of the media on the
 * uri property, it will extact the metadata for you and emit signal
 * metadata_available for each key/value pair extracted.
 */
GType rygel_media_export_metadata_extractor_get_type (void) {
	static volatile gsize rygel_media_export_metadata_extractor_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_media_export_metadata_extractor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMediaExportMetadataExtractorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_media_export_metadata_extractor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediaExportMetadataExtractor), 0, (GInstanceInitFunc) rygel_media_export_metadata_extractor_instance_init, NULL };
		GType rygel_media_export_metadata_extractor_type_id;
		rygel_media_export_metadata_extractor_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediaExportMetadataExtractor", &g_define_type_info, 0);
		g_once_init_leave (&rygel_media_export_metadata_extractor_type_id__volatile, rygel_media_export_metadata_extractor_type_id);
	}
	return rygel_media_export_metadata_extractor_type_id__volatile;
}



